/*
 * $Id$
 *
 * Create new entries of an passwd file format for CVS pserver.
 *
 * This is free software with ABSOLUTELY NO WARRANTY.
 * You can redistribute it and/or modify it under the terms of
 * the GNU General Public License version 2.
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#define TRUE !0
#define FALSE 0
#define BUFLEN 256

int add_user(char *buf);
char *input_text(char *text, int len, const char *message);
char *input_password(char *text, int len, const char *message);
void crypt_text(char **crypttext, const char *plaintext);
void draw_salt(char *salt);


int main(void)
{
  char buf[BUFLEN];
  int flag = FALSE;

  while ((flag = add_user(buf))) {
    fprintf(stdout, "%s", buf);
  }
  return EXIT_SUCCESS;
}

int add_user(char *buf)
{
  char cvs_account[BUFLEN];
  char passwd[BUFLEN], tmp_passwd[BUFLEN], *encoded_passwd;
  char real_account[BUFLEN];

  if (input_text(cvs_account, BUFLEN, "cvs account: ") == NULL) {
    return FALSE;
  }
  input_password(passwd, BUFLEN, "password: ");
  input_password(tmp_passwd, BUFLEN, "Re-enter password: ");
  if (strcmp(passwd, tmp_passwd) != 0) {
    fprintf(stderr, "ERROR! They don't match.\n");
    return FALSE;
  }
  crypt_text(&encoded_passwd, passwd);
  input_text(real_account, BUFLEN, "real account (can be omitted): ");
  if (strlen(real_account) > 0) {
    sprintf(buf, "%s:%s:%s\n", cvs_account, encoded_passwd, real_account);
  } else {
    sprintf(buf, "%s:%s\n", cvs_account, encoded_passwd);
  }
  return TRUE;
}

char *input_text(char *text, int len, const char *message)
{
  char *p;

  fprintf(stderr, "%s", message);
  if (fgets(text, len, stdin) == NULL) {
    *text = '\0';
    return NULL;
  }
  p = index(text, '\n');
  if (p != NULL) {
    *p = '\0';
  }
  return text;
}

char *input_password(char *text, int len, const char *message)
{
  char *p;

  system("stty -echo");
  system("stty echonl");
  p = input_text(text, len, message);
  system("stty echo");
  return p;
}

void crypt_text(char **crypttext, const char *plaintext)
{
  char salt[3];

  draw_salt(salt);
  *crypttext = crypt(plaintext, salt);
}

void draw_salt(char *salt)
{
  const char *salt_chars =
    "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";
  int idx1, idx2;
  char chr1, chr2;
  size_t len;

  len = strlen(salt_chars);
  idx1 = (int)((double)rand()/RAND_MAX*len);
  idx2 = (int)((double)rand()/RAND_MAX*len);
  chr1 = salt_chars[idx1];
  chr2 = salt_chars[idx2];
  *(salt++) = chr1;
  *(salt++) = chr2;
  *(salt++) = '\0';
}
