#!/usr/bin/perl
# $Id$
#
# Create new entries of an passwd file format for CVS pserver.
#
# This is free software with ABSOLUTELY NO WARRANTY.
# You can redistribute it and/or modify it under the terms of 
# the GNU General Public License version 2.
#

use strict;

#srand(time() ^ ($$ << 15));
srand(0);
my $cvs_passwd = "";
my $line = "";
do {
    $line = add_user();
    print $line;
} while(defined($line));
exit(0);


## Add user.
#
sub add_user {
    my $cvs_account = input_text("cvs account: ");
    if (length($cvs_account) <= 0) {
        return undef;
    }
    my $passwd = input_password("password: ");
    my $tmp_passwd = input_password("Re-enter password: ");
    unless ($passwd eq $tmp_passwd) {
        print STDERR "ERROR! They don't match.\n";
        return undef;
    }
    my $real_account = input_text("real account (can be omitted): ");
    my $encoded_passwd = crypt_text($passwd);
    my $line = cvs_passwd_line($cvs_account, $encoded_passwd, $real_account);
    return $line;
}

sub input_text {
    my ($message) = (@_);
    print STDERR $message;
    my $text = <STDIN>;
    if (defined($text)) {
        chomp $text;
    }
    return $text;
}

sub input_password {
    my ($message) = (@_);
    print STDERR $message;
    system "stty -echo";
    my $passwd = <STDIN>;
    system "stty echo";
    if (defined($passwd)) {
        chomp $passwd;
    }
    print STDERR "\n";
    return $passwd;
}

sub cvs_passwd_line {
    my ($cvs_account, $encoded_passwd, $real_account) = (@_);
    my $line = "$cvs_account:$encoded_passwd";
    $line .= (length($real_account) > 0) ? ":$real_account\n" : "\n";
    return $line;
}

sub crypt_text {
    my ($plaintext) = (@_);
    my $salt = draw_salt();
    my $crypttext = crypt($plaintext, $salt);

    return $crypttext;
}

sub draw_salt {
    my $salt_chars =
        'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./';
    my $idx1 = int(rand()*length($salt_chars));
    my $idx2 = int(rand()*length($salt_chars));
    my $chr1 = substr($salt_chars, $idx1, 1);
    my $chr2 = substr($salt_chars, $idx2, 1);

    return ($chr1 . $chr2);
}

